/*
stuff related to generating random numbers.
seeds will not be generated here, it is expected that things will be seeded
externally.
 */

#include "bsde_internal.h"

static unsigned int bsde_rng2_table[64];
static int bsde_rng2_i;
// static unsigned long long bsde_rng3_state;
static unsigned long bsde_rng3_state;

//first generator

void BSDE_SRand(bsdeUInt seed)
{
	bsde_rng3_state=seed;
}

void BSDE_SRand2(bsdeUInt seed1, bsdeUInt seed2)
{
	bsde_rng3_state=seed1;

//	bsde_rng3_state=seed2;
//	bsde_rng3_state=(bsde_rng3_state<<32)|seed1;
}

bsdeUInt BSDE_Rand()
{
	bsde_rng3_state=bsde_rng3_state * 65521 + 1;
	return((bsde_rng3_state>>16)&65535);

//	bsde_rng3_state=bsde_rng3_state * 6364136223846793005LL + 1;
//	return((bsde_rng3_state>>32)&65535);
}


//second generator
bsdeUInt BSDE_Rand2()
{
	bsde_rng2_i = (bsde_rng2_i+1) & 63;
	bsde_rng2_table[bsde_rng2_i] =
		bsde_rng2_table[(bsde_rng2_i-24) & 63] ^
		bsde_rng2_table[(bsde_rng2_i-55) & 63];
	return(bsde_rng2_table[bsde_rng2_i]);
}

void BSDE_Seed2(bsdeUInt s0, bsdeUInt s1)
{
	int i;
	bsde_rng2_table[0]=s0;
	bsde_rng2_table[1]=s1;

	for(i=2; i<55; i++)
		bsde_rng2_table[i]=bsde_rng2_table[i-1]*11+
			bsde_rng2_table[i-2]*19/16;					
}

void BSDE_Seed21()
{
	int i;
	for(i=0; i<64; i++)
	{
//		bsde_rng3_state=bsde_rng3_state * 6364136223846793005LL + 1;
//		bsde_rng2_table[i]=bsde_rng3_state>>32;

		bsde_rng2_table[i]=BSDE_Rand()|(BSDE_Rand()<<16);
	}
}


//joint generator
bsdeUInt BSDE_RandJ()
{
	bsdeUInt i;

	i=BSDE_Rand()*BSDE_Rand2();
	return(i);
}


//random value between 0 and 1
double BSDE_RandF()
{
	double f;

	f=((double)BSDE_Rand2())/4294967295.0;
	return(f);
}

//random value between -1 and 1
double BSDE_RandG()
{
	return(2*BSDE_RandF()-1);
}
